from __future__ import unicode_literals
import json
import frappe
import frappe.defaults
from frappe.desk.star import _toggle_star

def execute():
	for user in frappe.get_all("User"):
		username = user["name"]
		bookmarks = frappe.db.get_default("_bookmarks", username)

		if not bookmarks:
			continue

		if isinstance(bookmarks, basestring):
			bookmarks = json.loads(bookmarks)

		for opts in bookmarks:
			route = (opts.get("route") or "").strip("#/ ")

			if route and route.startswith("Form"):
				view, doctype, docname = opts["route"].split("/")

				if frappe.db.exists(doctype, docname):
					_toggle_star(doctype, docname, add="Yes", user=username)
